#include "bonus.h"
#include "box.h"
#include "mario.h"
#include "world.h"
#include "tile.h"
#include "score.h"
#include "ennemi.h"
#include "constants.h"
#include <stdbool.h>
#include <base.h>
#include <camera.h>

static bonus_t bonus ={BONUS_NONE, {0,0,TILE_W,TILE_H,0,0,0,1}, 0};

void bonusSet(bonus_id t, int x, int y)
{
	bonus.type=t;
	if (mario.p.h==M_BIG && t==BONUS_CHAMPI)
		bonus.type=BONUS_FLEUR;
	bonus.b.x=x;
	bonus.b.y=y;
	bonus.b.vx=0;
	bonus.b.vy=0;
	bonus.p1=0;
}

void bonusMove() //+collision
{
	if (bonus.type==BONUS_NONE)
		return;

	if (bonus.type==BONUS_STAR)
	{
		boxJump(&bonus.b,4);
	}
	boxMove(&bonus.b);
	if (bonus.type==BONUS_CHAMPI || bonus.type==BONUS_1UP || bonus.type==BONUS_STAR)
	{

		if (bonus.b.vx==0)
		{
			if (bonus.p1==0)
			{
				bonus.b.vx=2;
				bonus.p1=1;
			}
			else
			{
				bonus.p1*=-1;
				bonus.b.vx=2*bonus.p1;
			}
		}
		if (bonus.b.y<0)
			bonusSet(BONUS_NONE,0,0);
	}

	int collide=boxContact(&mario.p, &bonus.b);
	if (collide && bonus.type!=BONUS_NONE)
	{
		switch (bonus.type)
		{
			case BONUS_CHAMPI:
			case BONUS_FLEUR:
			if (mario.p.h==M_SMALL) marioBigger();
			else mario.bullets=1;
			break;

			case BONUS_1UP:
			lifesAdd(1);
			break;

			case BONUS_STAR:
			bonusSet(BONUS_NONE,0,0);
			mario.starMode=1;
		}
		scoreAdd(1000);
		bonusSet(BONUS_NONE,0,0);
	}
}

void bonusDraw()
{
	//bonusMove();
	if (bonus.type==BONUS_NONE)
		return;
	if (bonus.type==BONUS_CHAMPI)
		tileDraw(bonus.b.x-cameraX(), bonus.b.y-cameraY(), &champi, 0,0);
	if (bonus.type==BONUS_FLEUR)
		tileDraw(bonus.b.x-cameraX(), bonus.b.y-cameraY(), &fleur, 0,0);
	if (bonus.type==BONUS_1UP)
		tileDraw(bonus.b.x-cameraX(), bonus.b.y-cameraY(), &life_1up, 0,0);
	if (bonus.type==BONUS_STAR)
		tileDraw(bonus.b.x-cameraX(), bonus.b.y-cameraY(), &mario_starman, 0,0);
}
